package misc

import (
	"encoding/json"
	"skunkyart/post"
	"skunkyart/user"
	"skunkyart/util"
	"strconv"
)

func GetGroup(action, folderid, name string, page int) string {
	switch action {
	case "":
		return about(name, page)
	case "gallery":
		f := getfolders(&name)
		if folderid != "" {
			var j struct {
				Results []util.Deviation
			}
			rjs := util.Puppy("dashared/gallection/contents?username=" + name + "&type=gallery&offset=" + strconv.Itoa(50*page) + "&limit=50&folderid=" + folderid)
			json.Unmarshal([]byte(rjs), &j)

			return util.BaseList("templates/search.htm", "&a=gallery&folder="+folderid, "group/"+name, j.Results, page, f)
		} else {
			var c = make(chan string, 10)
			if page < 1 {
				page++
			}
			go user.Gallery(&name, c, strconv.Itoa(page), f)
			return <-c
		}
	}
	return ""
}

func getfolders(name *string) string {
	var j util.AB
	rjs := util.Puppy("dauserprofile/init/gallery?username=" + *name + "&deviations_limit=0&with_subfolders=true")
	json.Unmarshal([]byte(rjs), &j)

	var folders string
	for _, a := range j.Gruser.Page.Modules {
		for _, a := range a.ModuleData.Folders.Results {
			folders += "<a href=\"" + util.Conf.Base_uri + "group/" + *name + "?a=gallery&folder=" + strconv.Itoa(a.FolderId) + "\">" + a.Name + "</a> "
		}
	}
	return folders
}

func about(name string, page int) string {
	var tmp struct {
		Name, Description, Foundation, Status, Comments, Bg, Bgname string
		V, P                                                        int
	}
	var j util.AB
	rjs := util.Puppy("dauserprofile/init/about?username=" + name)
	json.Unmarshal([]byte(rjs), &j)

	tmp.Name = j.Owner.Username
	tmp.Status = j.PageExtraData.GruserTagline
	uid := make([]string, 1)
	uid[0] = strconv.Itoa(j.Gruser.GruserId)
	tmp.Comments = *post.GetComments(util.Conf.Base_uri+"group/"+tmp.Name, "", page+1, 4, uid)
	for _, a := range j.Gruser.Page.Modules {
		if a.ModuleData.GroupAbout.FoundationTs.Unix() > 0 {
			tmp.Foundation = a.ModuleData.GroupAbout.FoundationTs.UTC().String()
		}
		if a.ModuleData.GroupAbout.Description.Html.Markup != "" {
			tmp.Description += util.ParseDescription(a.ModuleData.GroupAbout.Description)
		}

		tmp.Bg = util.Images(a.ModuleData.CoverDeviation.CoverDeviation, a.ModuleData.CoverDeviation.CoverDeviation.Media, true)
		tmp.Bgname = a.ModuleData.CoverDeviation.CoverDeviation.Title
	}

	tmp.V = j.PageExtraData.Stats.Watchers
	tmp.P = j.PageExtraData.Stats.Pageviews

	return util.TmpExec("templates/group.htm", &tmp)
}
