package misc

import (
	"skunkyart/util"
	"strings"
)

var Extensions = [3]string{
	".jpg",
	".png",
	".gif",
}

func get(scope, name string) string {
	var uri string
	switch scope {
	case "avatar":
		uri = "https://a.deviantart.net/avatars-big" + "/" + string(name[0:1]) + "/" + string(name[1:2]) + "/" + name
	case "emoji":
		uri = "https://e.deviantart.net/emoticons/" + name[0:1] + "/" + name
	}

	for x := 0; x < len(Extensions); x++ {
		image := util.Cache(uri + Extensions[x])
		if image != "Failed to get image." {
			return image
		}
	}
	return ""
}

func Misc(name string, emoji bool) string {
	if emoji {
		return get("emoji", name)
	}
	return get("avatar", name)
}

func Getimage(img string, token string) string {
	var imguri string
	if len(img) > 0 {
		imguri = "https://images-wixmp-" + img[0:strings.Index(img, "/")] + ".wixmp.com" + img[strings.Index(img, "/"):] + "?token=" + token
		return util.Cache(imguri)
	}
	return "Invalid uri."
}
