package user

import (
	"encoding/json"
	"strconv"
)

func Get(name, action, query string, page int) string {
	c := make(chan string, 100)

	switch action {
	case "":
		go about(&name, page, c)
	case "gallery":
		if page == 0 {
			page = 1
		}

		go Gallery(&name, c, strconv.Itoa(page))
	case "search":
		go search(&name, &query, page, c)
	}
	return <-c
}

func rerror(err *string) string {
	if len(*err) < 100 {
		var j struct {
			ErrorDescription string
		}

		json.Unmarshal([]byte(*err), &j)

		switch j.ErrorDescription {
		case "User deactivated.":
			return "User deactivated their account or has been banned."
		case "user_not_found.":
			return "Not exists user."
		default:
			if *err == "Something went wrong. Status: 403" {
				return "Rate limit from CloudFront."
			} else {
				return "Something went wrong."
			}
		}
	}
	return ""
}
