package util

import (
	"crypto/sha1"
	"fmt"
	"io"
	"os"
	"strings"
	"syscall"
	"time"
)

func check(what ...string) {
	if Conf.Cache.Max_size != 0 || Conf.Cache.Lifetime != 0 {
		for {
			dir, err := os.Open(Conf.Cache.Path)
			if err != nil {
				err = os.Mkdir(Conf.Cache.Path, 0700)
				Err(err)
			}
			stat, _ := dir.Stat()

			c, _ := dir.Readdirnames(-1)
			for _, a := range c {
				for _, b := range what {
					switch b {
					case "lifetime":
						if Conf.Cache.Lifetime != 0 {
							now := time.Now().UnixMilli()

							f, _ := os.Stat(Conf.Cache.Path + "/" + a)
							stat := f.Sys().(*syscall.Stat_t)
							time := time.Unix(stat.Ctim.Unix()).UnixMilli()

							if time+Conf.Cache.Lifetime <= now {
								os.RemoveAll(Conf.Cache.Path + "/" + a)
							}
						}
					case "maxsize":
						if Conf.Cache.Max_size != 0 && stat.Size() > Conf.Cache.Max_size {
							os.RemoveAll(Conf.Cache.Path + "/" + a)
						}
					}
				}
			}

			dir.Close()

			time.Sleep(time.Second)
		}
	}
}

func Cache(img string) string {
	if Conf.Cache.Enabled {
		os.Mkdir(Conf.Cache.Path, 0700)

		sum := sha1.Sum([]byte(img))
		encsum := fmt.Sprintf("%X", sum[:])
		file, err := os.Open(Conf.Cache.Path + "/" + encsum)

		if err != nil {
			body, status, _, h := Request(img, "")

			if status == 200 {
				for b, a := range h {
					if b == "Content-Type" {
						for _, a := range a {
							a = a[0:strings.Index(a, "/")]
							if a == "image" || a == "video" {
								err := os.WriteFile(Conf.Cache.Path+"/"+encsum, []byte(body), 0700)
								Err(err)

								return string(body)
							}
						}
					}
				}
			} else {
				return "Failed to get image."
			}
		} else {
			file, err := io.ReadAll(file)
			Err(err)
			return string(file)
		}
		file.Close()
	} else {
		body, _, _, _ := Request(img, "")
		return string(body)
	}
	return ""
}
