package util

import (
	"encoding/json"
	"log"
	"os"
)

type cconf struct {
	Enabled            bool
	Path               string
	Max_size, Lifetime int64
}

type c struct {
	Listen, Base_uri string
	Cache            cconf
	Proxy, Nsfw      bool
}

var Conf = c{
	Listen:   "127.0.0.1:3003",
	Base_uri: "/",
	Cache: cconf{
		Enabled: true,
		Path:    "cache",
	},
	Proxy: true,
	Nsfw:  true,
}

func ParseConfig() {
	cfile := "config.json"

	for b, a := range os.Args {
		if len(a) > 2 && a[0:2] == "--" {
			a = a[2:]
			switch a {
			case "help":
				println(`SkunkyArt v1.2
Usage:
	- config: specify config file path;
	- help: prints this message.
Example:
	./skunkyart --config /services/skunkyart/config.json

lost+skunk, 2024. Source Code: https://git.macaw.me/skunky/skunkyart`)
				os.Exit(0)
			case "config":
				file, err := os.ReadFile(os.Args[b+1])
				if err != nil {
					log.Fatalln(err.Error())
				}

				if len(file) > 0 {
					if string(file)[0:1] == "{" {
						cfile = os.Args[b+1]
					} else {
						log.Fatalln("Invalid config file.")
					}
				}
			}
		}
	}

	file, err := os.ReadFile(cfile)
	if err != nil {
		panic(err.Error())
	}

	json.Unmarshal(file, &Conf)

	go check("lifetime", "maxsize")
}
